﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApp1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var dtstart=DateTime.Now;

            this.viewmodel.search1();

            var dtend=DateTime.Now;
            var tspan=dtend.Subtract(dtstart);
            this.viewmodel.binding_time1=tspan.ToString();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            var dtstart=DateTime.Now;

            this.FG2.ItemsSource=null;
            this.viewmodel.search2();
            this.FG2.ItemsSource=this.viewmodel.binding_itemssource2;;
            
            var dtend=DateTime.Now;
            var tspan=dtend.Subtract(dtstart);
            this.viewmodel.binding_time2=tspan.ToString();
        }
    }
    public class MyObservableCollection<T> : ObservableCollection<T>
    {
        protected override void OnCollectionChanged(NotifyCollectionChangedEventArgs e)
        {
            if (!_addingRange)
                base.OnCollectionChanged(e);
        }

        private bool _addingRange;

        public void AddRange(IEnumerable<T> newItems)
        {
            int startingIndex = Count;
            var newItemsList = newItems.ToList();
            try
            {
                _addingRange = true;
                foreach (T item in newItemsList)
                {
                    Add(item);
                }
            }
            finally { _addingRange = false; }
            OnCollectionChanged(new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Add, (System.Collections.IList)newItemsList, startingIndex));
        }
    }
}
