﻿using System;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WpfApp1
{
    public class ViewModel : System.ComponentModel.INotifyPropertyChanged
    { 
                                                                                        //........................................................................................ update modify to view
                                                                                        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
                                                                                        protected void OnPropertyChanged(string property_name)
                                                                                        {
                                                                                            if ( PropertyChanged!=null )
                                                                                                PropertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(property_name));
                                                                                        }
                                                                                        //........................................................................................ clone

        public MyObservableCollection<TRecord> binding_itemssource1 { get; set; }
        public ObservableCollection<TRecord> binding_itemssource2 { get; set; }

        string _time1 { get; set; }
        public string binding_time1 
        { 
            get { return _time1; }
            set
            {
                _time1=value;
                this.OnPropertyChanged("binding_time1");
            }
        }
        
        string _time2 { get; set; }
        public string binding_time2 
        { 
            get { return _time2; }
            set
            {
                _time2=value;
                this.OnPropertyChanged("binding_time2");
            }
        }


        public ViewModel()
        {
            this.binding_itemssource1=new MyObservableCollection<TRecord>();
            this.binding_itemssource2=new ObservableCollection<TRecord>();
        }


        public void search1()
        {
            this.binding_itemssource1.Clear();
            this.binding_itemssource1.AddRange(Enumerable.Range(0, 100000).Select(i => new TRecord(i + 1)));
        }

        public void search2()
        {
            this.binding_itemssource2.Clear();

            for (int i = 0; i < 100000; i++)
            {
                this.binding_itemssource2.Add(new TRecord(i+1));
            }
        }


        public class TRecord
        {
            public string fields1 { get; set; }
            public string fields2 { get; set; }
            public string fields3 { get; set; }
            public string fields4 { get; set; }
            public string fields5 { get; set; }
            public string fields6 { get; set; }
            public string fields7 { get; set; }
            public string fields8 { get; set; }
            public string fields9 { get; set; }
            public string fields10 { get; set; }

            public TRecord(int n)
            {
                this.fields1=n.ToString();
                this.fields2=n.ToString();
                this.fields3=n.ToString();
                this.fields4=n.ToString();
                this.fields5=n.ToString();
                this.fields6=n.ToString();
                this.fields7=n.ToString();
                this.fields8=n.ToString();
                this.fields9=n.ToString();
                this.fields10=n.ToString();
            }
        }
    }
}
